=== debian/changelog ===
minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-4build3) noble; urgency=medium

  * No-change rebuild for CVE-2024-3094

 -- William Grant <wgrant@ubuntu.com>  Mon, 01 Apr 2024 17:56:28 +1100

minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-4build2) noble; urgency=medium

  * No-change rebuild against libcurl3t64-gnutls

 -- Steve Langasek <steve.langasek@ubuntu.com>  Sat, 16 Mar 2024 07:10:05 +0000

minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-4build1) noble; urgency=medium

  * No-change rebuild against libpng16-16t64

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 29 Feb 2024 07:22:42 +0000

minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-4) unstable; urgency=medium

  * Team upload.

  [ Helmut Grohne ]
  * Non-maintainer upload.
  * Install minetest-server@.service only once when dh_installsystemd
    moves units to /usr. (Closes: #1055799)

  [ Tobias Frost ]
  * Upload with Helmut's patch.

 -- Tobias Frost <tobi@debian.org>  Sun, 26 Nov 2023 11:07:22 +0100

minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Fix build with nocheck profile, see d/rules for details (Closes: #1052671)
  * Drop Depends on lsb-base, fixes E: depends-on-obsolete-package.
  * Change B-D from libfreetype6-dev to libfreetype-dev, fixes build-
    depends-on-obsolete-package.
  * Update S-V to 4.6.2 - no changes.

 -- Tobias Frost <tobi@debian.org>  Sat, 11 Nov 2023 11:43:28 +0100

minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-2) unstable; urgency=medium

  * Mark fix-typos.patch as been applied upstream.
  * Rewrite patch to add packaged mods support. (Closes: 1021944)

 -- Tobias Frost <tobi@debian.org>  Sat, 22 Oct 2022 13:09:24 +0200

minetest (5.6.1+dfsg+~1.9.0mt8+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version.
  * Refresh shared_mods.patch
  * Patch to use Lua-C++ instead of the C library.
  * Remove fix-test-lua.patch.
  * Make sure that testLuaDestructors is really disabled.

 -- Tobias Frost <tobi@debian.org>  Wed, 21 Sep 2022 18:52:12 +0200

minetest (5.6.0+dfsg+~1.9.0mt7+dfsg-3) unstable; urgency=medium

  * Team upload.
  * Reenable build time unittstess, disabling testLuaDestructors test.
  * Update architecture list where luajit is available.

 -- Tobias Frost <tobi@debian.org>  Tue, 20 Sep 2022 18:13:56 +0200

minetest (5.6.0+dfsg+~1.9.0mt7+dfsg-2) unstable; urgency=medium

  * Team upload.
  * Temporarily revert "Enable unittests during build.", they uncovered
    testsuite failures, but this is not a regression…

 -- Tobias Frost <tobi@debian.org>  Sat, 17 Sep 2022 07:51:04 +0200

minetest (5.6.0+dfsg+~1.9.0mt7+dfsg-1) unstable; urgency=medium

  * Team upload.
  * New upstream version. Closes: #1019871.
    - CVE-2022-35978.patch is no longer needed.
    - New upstream version Closes: #1010827, #996663
    - Upstream fixed security issues:
      - HTTP API access control bypass (no CVE issued)
  * Patches:
    - Refreshing patches.
    - Forwarding fix-typos.patch upstream.
  * As upstream requires SSE3 to function properly, depend on sse3-support to
    ensure minetest can only installed on i386 machines with that CPU feature.
    (Closes: #1010760)
  * Review d/copyright.
  * Bump S-V to 4.6.1 -- no changes required.
  * Don't install optimize_textures.sh.
  * Build with debug infos.
  * Enable unittests during build.
  * Add autopkgtest.
    - Add patch to make unittests not requiring build directory be available.
  * Enable out-of-tree build, so that cleanup is easier.
  * Add custom salsa-ci.yaml to override repotest.

 -- Tobias Frost <tobi@debian.org>  Fri, 16 Sep 2022 23:09:33 +0200

minetest (5.5.0+dfsg+~1.9.0mt4+dfsg-2) unstable; urgency=medium

  * Fix CVE-2022-35978:
    In **single player**, a mod can set a global setting that controls the Lua
    script loaded to display the main menu. The script is then loaded as soon
    as the game session is exited. The Lua environment the menu runs in is not
    sandboxed and can directly interfere with the user's system. There are
    currently no known workarounds. (Closes: #1017548)

 -- Markus Koschany <apo@debian.org>  Thu, 18 Aug 2022 22:26:07 +0200
